--- /dev/null	Sun Jul 27 18:01:36 2014
+++ new/usr/src/man/man3nsl/gethostent.3nsl	Sun Jul 27 18:01:36 2014
@@ -0,0 +1,288 @@
+.\" Copyright 2014 Garrett D'Amore <garrett@damore.org>
+.\" Copyright (C) 2008, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright 1989 AT&T.
+.\" Portions Copyright (c) 1992, X/Open Company Limited. All Rights Reserved
+.\" Sun Microsystems, Inc. gratefully acknowledges The Open Group for permission to reproduce portions of its copyrighted documentation. Original documentation from The Open Group can be obtained online at
+.\" http://www.opengroup.org/bookstore/.
+.\" The Institute of Electrical and Electronics Engineers and The Open Group, have given us permission to reprint portions of their documentation. In the following statement, the phrase "this text" refers to portions of the system documentation. Portions of this text are reprinted and reproduced in electronic form in the Sun OS Reference Manual, from IEEE Std 1003.1, 2004 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2004 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between these versions and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html.
+.\"  This notice shall appear on any product containing this material.
+.\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
+.\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
+.Dd Jul 22, 2014
+.Dt GETHOSTBYNAME 3NSL
+.Os
+.Sh NAME
+.Nm gethostent, gethostent_r, sethostent, endhostent
+.Nd enumerate network host entries
+.Sh SYNOPSIS
+.Ic cc
+.Op Ar flag No Ns ...
+.Ar file No Ns ...
+.Fl lnsl
+.Op Ar library No Ns ...
+.Lp
+.In netdb.h
+.Ft "struct hostent *"
+.Fn gethostent "void"
+.Ft "struct hostent *"
+.Fo gethostent_r
+.Fa "struct hostent *result"
+.Fa "char *buffer"
+.Fa "int buflen"
+.Fa "int *h_errnop"
+.Fc
+.Ft int
+.Fn sethostent "int stayopen"
+.Ft int
+.Fn endhostent void
+.Sh DESCRIPTION
+These functions are used to enumerate entries in the network hosts database.
+An entries can come
+from any of the sources for
+.Sy hosts
+specified in the
+.Pa /etc/nsswitch.conf
+file. See
+.Xr nsswitch.conf 4 .
+.Lp
+All addresses are returned in network order. In order to interpret the
+addresses,
+.Xr byteorder 3SOCKET
+must be used for byte order conversion.
+.Lp
+The
+.Fn sethostent
+function sets or resets the enumeration to the beginning
+of the set of host entries. This function should be called before the first
+call to
+.Fn gethostent .
+If the
+.Fa stayopen
+flag is non-zero, the system can keep allocated resources
+such as open file descriptors until a subsequent call to
+.Fn endhostent .
+.Lp
+Successive calls to the
+.Fn gethostent
+function return either successive
+entries or
+.Dv NULL ,
+indicating the end of the enumeration.
+.Lp
+The
+.Fn endhostent()
+function can be called to indicate that the caller
+expects to do no further host entry retrieval operations; the system can then
+deallocate resources it was using. It is still allowed, but possibly less
+efficient, for the process to call more host retrieval functions after calling
+.Fn endhostent .
+.Lp
+The
+.Fn gethostent
+function uses static storage that is reused in each call, making this
+function unsafe for use in multithreaded applications.
+.Lp
+The
+.Fn gethostent_r
+function performs the same function as
+.Fn gethostent, but provides a reentrant interface.
+It uses a buffer supplied by the caller to store returned results and
+is safe for use in both single-threaded and multithreaded applications.
+.Lp
+The
+.Fn gethostent_r
+function takes the same parameters as
+.Fn gethostent ,
+as well as the following additional parameters. The parameter
+.Fa result
+must be a pointer to a
+.Vt "struct hostent"
+structure allocated by the caller. On successful completion, the function
+returns the host entry in
+this structure. The parameter
+.Fa buffer
+must be a pointer to a buffer
+supplied by the caller. This buffer is used as storage space for the host data.
+All of the pointers within the returned
+.Vt "struct hostent"
+point to data stored within this buffer. See the
+.Sx RETURN VALUES
+section for more
+information. The buffer must be large enough to hold all of the data associated
+with the host entry. The parameter
+.Fa buflen
+should give the size in bytes
+of the buffer indicated by
+.Fa buffer . The parameter
+.Fa h_errnop
+should be
+a pointer to an integer. An integer error status value is stored there on
+certain error conditions. See the
+.Sx ERRORS
+section for more information.
+.Sh RETURN VALUES
+The
+.Fn gethostent
+and
+.Fn gethostent_r
+functions each return a pointer
+to a
+.Vt "struct hostent"
+if they successfully enumerate an entry; otherwise they return
+.Dv NULL ,
+indicating the end of the enumeration.  See
+.Xr gethostbyname 3NSL
+for a descriptin of the
+.Vt "struct hostent"
+structure.
+.Lp
+The
+.Fn gethostent
+function uses static storage, so results from from one call may be overwritten
+by subsequent calls it.
+.Lp
+When the pointer returned by
+.Fn gethostent_r
+is not
+.Dv NULL , it is
+always equal to the
+.Fa result
+pointer that was supplied by the caller.
+.Lp
+The
+.Fn sethostent
+and
+.Fn endhostent
+functions return 0 on success.
+.Sh FILES
+.Bl -tag -width "/etc/nsswitch.conf"
+.It Pa /etc/hosts
+hosts file that associates the names of hosts with their Internet Protocol (IP)
+addresses
+.It Pa /etc/nsswitch.conf
+configuration file for the name service switch
+.El
+.Sh ERRORS
+The
+.Fn gethostent_r
+function will return
+.Dv NULL
+and set
+.Va errno
+to
+.Er ERANGE
+if the length of the buffer supplied by caller is not large enough to store the
+result.  It may also store one of the following
+.Va h_errno
+values into the location pointed by
+.Fa h_errnop .  On error, the
+.Fn gethostent
+function will set the global
+.Va h_errno
+value to one of these values:
+.Dv HOST_NOT_FOUND ,
+.Dv TRY_AGAIN ,
+.Dv NO_RECOVERY ,
+.Dv NO_DATA ,
+.Dv NO_ADDRESS ,
+or
+.Dv NETDB_INTERNAL .
+.Sh INTERFACE STABILITY
+The
+.Fn gethostent ,
+.Fn sethostent ,
+and
+.Fn endhostent
+functions are
+.Sy Standard .
+The
+.Fn gethostent_r
+function is
+.Sy Obsolete Uncommitted .
+.Sh MT-LEVEL
+The
+.Fn gethostent
+function is
+.Sy Unsafe .
+.Lp
+The
+.Fn gethostent_r ,
+.Fn sethostent ,
+and
+.Fn endhostent
+functions are
+.Sy Safe with Exceptions .
+For enumeration in multithreaded applications, the position within the
+enumeration is a process-wide property shared by all threads.
+If multiple threads interleave
+calls to these functions,
+the threads will enumerate disjoint subsets of the host database.
+.Sh SEE ALSO
+.Xr byteorder 3SOCKET ,
+.Xr gethostbyname 3NSL ,
+.Xr netdb.h 3HEAD ,
+.Xr hosts 4 ,
+.Xr nss 4 ,
+.Xr nsswitch.conf 4 ,
+.Xr standards 5
+.Sh NOTES
+The
+.Fn gethostent_r
+function is provided as an
+.Sy Uncommitted
+interface, and is subject to removal or change in a subsequent release.
+.Lp
+The
+.Fn gethostent
+and
+.Fn gethostent_r
+functions must always return the
+.Em canonical name
+in the
+.Fa h_name
+field. This name, by definition, is
+the well-known and official hostname shared between all aliases and all
+addresses. The underlying source that satisfies the request determines the
+mapping of the input name or address into the set of names and addresses in
+.Fa hostent .
+Different sources might do that in different ways. If there is
+more than one alias and more than one address in
+.Fa hostent ,
+no pairing is implied between them.
+.Lp
+The system attempts to put those addresses that are on the same subnet as the
+caller before addresses that are on different subnets. However, if address
+sorting is disabled by setting
+.Sy SORT_ADDRS
+to
+.Sy FALSE
+in the
+.Pa /etc/default/nss
+file, the system does not put the local subnet addresses
+first. See
+.Xr nss 4
+for more information.
+.Lp
+Use of these enumeration functions
+is discouraged; enumeration might not be supported for all database sources.
+The semantics of enumeration are discussed further in
+.Xr nsswitch.conf 4 .
+.Lp
+The current implementations of these functions only return addresses
+for the Internet address family
+.Po type Dv AF_INET Pc .
+See
+.Xr inet 4
+for more information.
+.Sh STANDARDS
+The
+.Fn gethostent ,
+.Fn sethostent ,
+and
+.Fn endhostent
+functions were introduced in
+.Bx 4.2
+and standardized in
+.St -xns5.2 and
+.St -p1003.1-2001 .
--- old/usr/src/pkg/manifests/system-library.man3c.inc	Sun Jul 27 18:01:37 2014
+++ new/usr/src/pkg/manifests/system-library.man3c.inc	Sun Jul 27 18:01:37 2014
@@ -488,8 +488,11 @@
 file path=usr/share/man/man3c/waitpid.3c
 file path=usr/share/man/man3c/walkcontext.3c
 file path=usr/share/man/man3c/wcrtomb.3c
+file path=usr/share/man/man3c/wcscasecmp.3c
 file path=usr/share/man/man3c/wcscoll.3c
+file path=usr/share/man/man3c/wcsdup.3c
 file path=usr/share/man/man3c/wcsftime.3c
+file path=usr/share/man/man3c/wcslen.3c
 file path=usr/share/man/man3c/wcsrtombs.3c
 file path=usr/share/man/man3c/wcsstr.3c
 file path=usr/share/man/man3c/wcstod.3c
@@ -1301,6 +1304,7 @@
 link path=usr/share/man/man3c/watol.3c target=wcstol.3c
 link path=usr/share/man/man3c/watoll.3c target=wcstol.3c
 link path=usr/share/man/man3c/wcrtomb_l.3c target=wcrtomb.3c
+link path=usr/share/man/man3c/wcscasecmp_l.3c target=wcscasecmp.3c
 link path=usr/share/man/man3c/wcscat.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcschr.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcscmp.3c target=wcstring.3c
@@ -1308,10 +1312,12 @@
 link path=usr/share/man/man3c/wcscpy.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcscspn.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcsetno.3c target=cset.3c
-link path=usr/share/man/man3c/wcslen.3c target=wcstring.3c
+link path=usr/share/man/man3c/wcsncasecmp.3c target=wcscasecmp.3c
+link path=usr/share/man/man3c/wcsncasecmp_l.3c target=wcscasecmp.3c
 link path=usr/share/man/man3c/wcsncat.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcsncmp.3c target=wcstring.3c
 link path=usr/share/man/man3c/wcsncpy.3c target=wcstring.3c
+link path=usr/share/man/man3c/wcsnlen.3c target=wcslen.3c
 link path=usr/share/man/man3c/wcsnrtombs.3c target=wcsrtombs.3c
 link path=usr/share/man/man3c/wcsnrtombs_l.3c target=wcsrtombs.3c
 link path=usr/share/man/man3c/wcspbrk.3c target=wcstring.3c
--- old/usr/src/pkg/manifests/system-library.man3nsl.inc	Sun Jul 27 18:01:37 2014
+++ new/usr/src/pkg/manifests/system-library.man3nsl.inc	Sun Jul 27 18:01:37 2014
@@ -12,11 +12,13 @@
 #
 # Copyright 2011, Richard Lowe
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 file path=usr/share/man/man3nsl/dial.3nsl
 file path=usr/share/man/man3nsl/doconfig.3nsl
 file path=usr/share/man/man3nsl/gethostbyname.3nsl
+file path=usr/share/man/man3nsl/gethostent.3nsl
 file path=usr/share/man/man3nsl/getipsecalgbyname.3nsl
 file path=usr/share/man/man3nsl/getipsecprotobyname.3nsl
 file path=usr/share/man/man3nsl/getnetconfig.3nsl
@@ -146,7 +148,7 @@
 link path=usr/share/man/man3nsl/clnttcp_create.3nsl target=rpc_soc.3nsl
 link path=usr/share/man/man3nsl/clntudp_bufcreate.3nsl target=rpc_soc.3nsl
 link path=usr/share/man/man3nsl/clntudp_create.3nsl target=rpc_soc.3nsl
-link path=usr/share/man/man3nsl/endhostent.3nsl target=gethostbyname.3nsl
+link path=usr/share/man/man3nsl/endhostent.3nsl target=gethostent.3nsl
 link path=usr/share/man/man3nsl/endnetconfig.3nsl target=getnetconfig.3nsl
 link path=usr/share/man/man3nsl/endnetpath.3nsl target=getnetpath.3nsl
 link path=usr/share/man/man3nsl/endrpcent.3nsl target=getrpcbyname.3nsl
@@ -157,8 +159,7 @@
 link path=usr/share/man/man3nsl/gethostbyaddr.3nsl target=gethostbyname.3nsl
 link path=usr/share/man/man3nsl/gethostbyaddr_r.3nsl target=gethostbyname.3nsl
 link path=usr/share/man/man3nsl/gethostbyname_r.3nsl target=gethostbyname.3nsl
-link path=usr/share/man/man3nsl/gethostent.3nsl target=gethostbyname.3nsl
-link path=usr/share/man/man3nsl/gethostent_r.3nsl target=gethostbyname.3nsl
+link path=usr/share/man/man3nsl/gethostent_r.3nsl target=gethostent.3nsl
 link path=usr/share/man/man3nsl/getipsecalgbynum.3nsl \
     target=getipsecalgbyname.3nsl
 link path=usr/share/man/man3nsl/getipsecprotobynum.3nsl \
@@ -219,7 +220,7 @@
 link path=usr/share/man/man3nsl/rpcb_rmtcall.3nsl target=rpcbind.3nsl
 link path=usr/share/man/man3nsl/rpcb_set.3nsl target=rpcbind.3nsl
 link path=usr/share/man/man3nsl/rpcb_unset.3nsl target=rpcbind.3nsl
-link path=usr/share/man/man3nsl/sethostent.3nsl target=gethostbyname.3nsl
+link path=usr/share/man/man3nsl/sethostent.3nsl target=gethostent.3nsl
 link path=usr/share/man/man3nsl/setnetconfig.3nsl target=getnetconfig.3nsl
 link path=usr/share/man/man3nsl/setnetpath.3nsl target=getnetpath.3nsl
 link path=usr/share/man/man3nsl/setrpcent.3nsl target=getrpcbyname.3nsl
--- old/usr/src/uts/common/sys/feature_tests.h	Sun Jul 27 18:01:37 2014
+++ new/usr/src/uts/common/sys/feature_tests.h	Sun Jul 27 18:01:37 2014
@@ -331,6 +331,32 @@
 #endif
 
 /*
+ * As another simplification attempt for the rest of our headers, we
+ * define the following macros to indicate that a specific XPG standard
+ * is in force, AND symbols should be restricted.  This lets us prune
+ * symbols that should not be visible under a given standard.  These should
+ * not be used by applications directly.
+ */
+#if defined(_STRICT_SYMBOLS) && defined(_XPG3)
+#define	_STRICT_XPG3
+#endif
+#if defined(_STRICT_SYMBOLS) && defined(_XPG4)
+#define	_STRICT_XPG4
+#endif
+#if defined(_STRICT_SYMBOLS) && defined(_XPG4_2)
+#define	_STRICT_XPG4_2
+#endif
+#if defined(_STRICT_SYMBOLS) && defined(_XPG5)
+#define	_STRICT_XPG5
+#endif
+#if defined(_STRICT_SYMBOLS) && defined(_XPG6)
+#define	_STRICT_XPG6
+#endif
+#if defined(_STRICT_SYMBOLS) && defined(_XPG7)
+#define	_STRICT_XPG7
+#endif
+
+/*
  * _XOPEN_VERSION is defined by the X/Open specifications and is not
  * normally defined by the application, except in the case of an XPG4
  * application.  On the implementation side, _XOPEN_VERSION defined with
--- old/usr/src/uts/common/sys/stat.h	Sun Jul 27 18:01:37 2014
+++ new/usr/src/uts/common/sys/stat.h	Sun Jul 27 18:01:37 2014
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 /*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
@@ -470,18 +471,8 @@
 
 #endif	/* __i386 || (__i386_COMPAT && _KERNEL) */
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
-/* for use with futimens() and utimensat() */
-#define	UTIME_NOW	-1L
-#define	UTIME_OMIT	-2L
-#endif	/* defined(__EXTENSIONS__) ... */
-
 #if !defined(_KERNEL) || defined(_BOOT)
 
-#if defined(__STDC__)
-
 #if !defined(__XOPEN_OR_POSIX) || (_POSIX_C_SOURCE > 2) || \
 	defined(_XPG4_2) || defined(__EXTENSIONS__)
 extern int fchmod(int, mode_t);
@@ -504,54 +495,20 @@
 #endif /* defined (_ATFILE_SOURCE) */
 #endif
 
-#if defined(__EXTENSIONS__) || defined(_ATFILE_SOURCE) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
+#if defined(_XPG7) || defined(_ATFILE_SOURCE)
 extern int mkdirat(int, const char *, mode_t);
 extern int mkfifoat(int, const char *, mode_t);
 extern int mknodat(int, const char *, mode_t, dev_t);
 extern int fchmodat(int, const char *, mode_t, int);
+#endif
+
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+#define	UTIME_NOW	-1L
+#define	UTIME_OMIT	-2L
 extern int futimens(int, const struct timespec[2]);
 extern int utimensat(int, const char *, const struct timespec[2], int);
-#endif	/* defined(__EXTENSIONS__) ... */
-
-#else /* !__STDC__ */
-
-#if !defined(__XOPEN_OR_POSIX) || (_POSIX_C_SOURCE > 2) || \
-	defined(_XPG4_2) || defined(__EXTENSIONS__)
-extern int fchmod();
-#endif /* !defined(__XOPEN_OR_POSIX) || (_POSIX_C_SOURCE > 2)... */
-
-extern int chmod();
-extern int mkdir();
-extern int mkfifo();
-extern mode_t umask();
-
-/* transitional large file interfaces */
-#if	defined(_LARGEFILE64_SOURCE) && !((_FILE_OFFSET_BITS == 64) && \
-	    !defined(__PRAGMA_REDEFINE_EXTNAME))
-extern int fstat64();
-extern int stat64();
-extern int lstat64();
-#if !defined(__XOPEN_OR_POSIX) || defined(__EXTENSIONS__) || \
-	defined(_ATFILE_SOURCE)
-extern int fstatat64();
-#endif /* defined (_ATFILE_SOURCE) */
 #endif
 
-#if defined(__EXTENSIONS__) || defined(_ATFILE_SOURCE) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
-extern int mkdirat();
-extern int mkfifoat();
-extern int mknodat();
-extern int fchmodat();
-extern int futimens();
-extern int utimensat();
-#endif	/* defined(__EXTENSIONS__) ... */
-
-#endif /* defined(__STDC__) */
-
 #include <sys/stat_impl.h>
 
 #endif /* !defined(_KERNEL) */
--- old/usr/src/uts/common/sys/timeb.h	Sun Jul 27 18:01:37 2014
+++ new/usr/src/uts/common/sys/timeb.h	Sun Jul 27 18:01:37 2014
@@ -3,16 +3,19 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
+
 #ifndef	_SYS_TIMEB_H
 #define	_SYS_TIMEB_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
 
 #include <sys/types.h>
+#include <sys/feature_tests.h>
 
 /*
  * Copyright (c) 1991, 1993
@@ -52,7 +55,16 @@
  * SUCH DAMAGE.
  */
 
-/* The ftime(2) system call structure */
+
+/*
+ * NOTE: This lives in sys/timeb.h due to standards requirements.
+ * The actual function is not a system call, but a libc function.  Hence
+ * this header should never be included into kernel modules.  Presumably
+ * the header shouldn't be included unless ftime() is desired, since it
+ * defines nothing else, but be pedantic.
+ */
+
+#if (!defined(_STRICT_SYMBOLS)) || (defined(_XPG4_2) && !defined(_XPG7))
 struct timeb {
 	time_t	time;			/* seconds since the Epoch */
 	unsigned short millitm;		/* + milliseconds since the Epoch */
@@ -60,10 +72,7 @@
 	short	dstflag;		/* DST == non-zero */
 };
 
-#if defined(__STDC__)
 extern int ftime(struct timeb *);
-#else
-extern int ftime();
 #endif
 
 #ifdef	__cplusplus
